#!/bin/sh -f
. /opt/CPshared/5.0/tmp/.CPprofile.sh
ECHO=/bin/echo
DATE=/bin/date
PS=/bin/ps
GREP=/bin/grep
PGREP=/bin/pgrep

# exit code should be unique, so each script starts with a different number
CPWD_IS_NOT_RUNNING=42
AMW_POLICY_IS_RUNNING=43

PACKAGE="TPCONF"
SCRIPT="Pre Verify"

$ECHO "start ${PACKAGE} - ${SCRIPT}"
$DATE

if [[ -z $($PGREP cpwd) ]]; then
       $ECHO "CPWD not running, can't install a new package"
       exit ${CPWD_IS_NOT_RUNNING}
fi

# If "fw amw fetch" is running, we wait 20 seconds and check again. Gives up after 4 minutes.
if [[ $($PS -ef | $GREP "amw fetch" | $GREP -v grep) ]]; then
        retries=12
        while [[ $retries -gt 0 ]]; do
            if [[ $($PS -ef | $GREP "fw amw fetch" | $GREP -v grep) ]]; then
                $ECHO "AMW policy installation is running, can't install a new package. Retry ($((13 - retries))/12) in 20 seconds"
                sleep 20
                retries=$((retries - 1))
            else
                break
            fi
        done

        if [[ $retries -eq 0 ]]; then
            $ECHO "Timeout: AMW policy installation is still running after 4 minutes"
            exit ${AMW_POLICY_IS_RUNNING}
        fi
fi
$ECHO "No AMW policy installation found, can install a new package"
exit 0
